/*************************************************************************\
**  source       * ssdir.h
**  directory    * ss
**  description  * Directory handling functions
**               * 
**               * 
**               * Copyright (C) 2006 Solid Information Technology Ltd
\*************************************************************************/
/*
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; only under version 2 of the License.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA
*/

#ifndef SSDIR_H
#define SSDIR_H

#include "ssenv.h"
#include "ssc.h"

typedef struct SsDirStruct SsDirT;
typedef struct SsDirEntStruct SsDirEntT;

struct SsDirEntStruct {

    char* filename;
    int used;

};

SsDirT    *SsDirOpen(char *pathname);
SsDirEntT *SsDirRead(SsDirT *dir);
void       SsDirClose(SsDirT *dir);

bool       SsDirMatch(char *wildpath, char *pathname);
bool       SsDirMatchNative(char *wildpath, char *pathname);

#endif /* SSDIR_H */


